/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

#include <string.h>
#include <assert.h>

#include "client-state-machine.h"
#include "state-machine-fns.h"
#include "shared-state-methods.h"
#include "pvfs2-types-debug.h"
#include "pvfs2-debug.h"
#include "job.h"
#include "gossip.h"
#include "str-utils.h"
#include "pint-servreq.h"
#include "pint-bucket.h"
#include "PINT-reqproto-encode.h"

extern job_context_id pint_client_sm_context;

enum
{
    IO_NO_DATA = 1,
    IO_DATAFILE_TRANSFERS_COMPLETE = 2,
    IO_RETRY = 3
};

static int io_init(
    PINT_client_sm *sm_p, job_status_s *js_p);
static int io_object_getattr_failure(
    PINT_client_sm *sm_p, job_status_s *js_p);
static int io_datafile_setup_msgpairs(
    PINT_client_sm *sm_p, job_status_s *js_p);
static int io_datafile_post_msgpairs(
    PINT_client_sm *sm_p, job_status_s *js_p);
static int io_datafile_complete_msgpairs(
    PINT_client_sm *sm_p, job_status_s *js_p);
static int io_analyze_results(
    PINT_client_sm *sm_p, job_status_s *js_p);

/* helper functions */
static int io_find_target_datafiles(
    PVFS_Request mem_req,
    PVFS_Request file_req,
    PVFS_offset file_req_offset, 
    PINT_dist *dist_p,
    PVFS_handle *input_handle_array,
    int input_handle_count,
    PVFS_handle *output_handle_array, 
    int *handle_index_array,
    int *handle_count_out_p);

#define CLEAN_PRIVATE_MEMBERS(iosm_p)       \
do {                                        \
    if (iosm_p->datafile_index_array)       \
    {                                       \
        free(iosm_p->datafile_index_array); \
        iosm_p->datafile_index_array = NULL;\
    }                                       \
    if (sm_p->msgarray &&                   \
        (sm_p->msgarray != &sm_p->msgpair)) \
    {                                       \
        free(sm_p->msgarray);               \
        sm_p->msgarray = NULL;              \
        sm_p->msgarray_count = 0;           \
    }                                       \
    if (iosm_p->flow_array)                 \
    {                                       \
        free(iosm_p->flow_array);           \
        iosm_p->flow_array = NULL;          \
    }                                       \
    if (iosm_p->flow_status_array)          \
    {                                       \
        free(iosm_p->flow_status_array);    \
        iosm_p->flow_status_array = NULL;   \
    }                                       \
    if (iosm_p->session_tag_array)          \
    {                                       \
        free(iosm_p->session_tag_array);    \
        iosm_p->session_tag_array = NULL;   \
    }                                       \
    if (iosm_p->ackarray)                   \
    {                                       \
        free(iosm_p->ackarray);             \
        iosm_p->ackarray = NULL;            \
    }                                       \
} while(0)

extern union PINT_state_array_values ST_init[];
extern union PINT_state_array_values ST_io_getattr_setup_msgpair[];
extern union PINT_state_array_values ST_io_getattr_xfer_msgpair[];
extern union PINT_state_array_values ST_io_getattr_failure[];
extern union PINT_state_array_values ST_io_datafile_setup_msgpairs[];
extern union PINT_state_array_values ST_io_datafile_post_msgpairs[];
extern union PINT_state_array_values ST_io_datafile_complete_msgpairs[];
extern union PINT_state_array_values ST_io_analyze_results[];

struct PINT_state_machine_s pvfs2_client_io_sm =
{
	ST_init,
	"pvfs2_client_io_sm"
};
static union PINT_state_array_values ST_init[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) io_init,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_getattr_setup_msgpair
};

static union PINT_state_array_values ST_io_getattr_setup_msgpair[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) PINT_sm_common_object_getattr_setup_msgpair,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_io_getattr_xfer_msgpair,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_getattr_failure
};

static union PINT_state_array_values ST_io_getattr_xfer_msgpair[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_client_getattr_acache_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_io_datafile_setup_msgpairs,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_getattr_failure
};

static union PINT_state_array_values ST_io_getattr_failure[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) io_object_getattr_failure,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_analyze_results
};

static union PINT_state_array_values ST_io_datafile_setup_msgpairs[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) io_datafile_setup_msgpairs,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_io_datafile_post_msgpairs,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_analyze_results
};

static union PINT_state_array_values ST_io_datafile_post_msgpairs[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) io_datafile_post_msgpairs,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_io_datafile_complete_msgpairs,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_analyze_results
};

static union PINT_state_array_values ST_io_datafile_complete_msgpairs[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) io_datafile_complete_msgpairs,
(union PINT_state_array_values) IO_DATAFILE_TRANSFERS_COMPLETE,
(union PINT_state_array_values) ST_io_analyze_results,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_io_datafile_complete_msgpairs
};

static union PINT_state_array_values ST_io_analyze_results[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) io_analyze_results,
(union PINT_state_array_values) IO_RETRY,
(union PINT_state_array_values) ST_init,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) 7
};

# 159 "src/client/sysint/sys-io.sm"


int PVFS_isys_io(
    PVFS_object_ref ref,
    PVFS_Request file_req,
    PVFS_offset file_req_offset,
    void *buffer,
    PVFS_Request mem_req,
    PVFS_credentials *credentials,
    PVFS_sysresp_io *resp_p,
    enum PVFS_io_type io_type,
    PVFS_sys_op_id *op_id,
    void *user_ptr)
{
    int ret = -PVFS_EINVAL;
    PINT_client_sm *sm_p = NULL;
    struct filesystem_configuration_s* cur_fs = NULL;
    struct server_configuration_s *server_config = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "PVFS_isys_io entered\n");

    if (resp_p == NULL)
    {
        gossip_lerr("NULL resp pointer\n");
        return ret;
    }

    if ((io_type != PVFS_IO_READ) && (io_type != PVFS_IO_WRITE))
    {
        return ret;
    }

    server_config = PINT_get_server_config_struct(ref.fs_id);
    cur_fs = PINT_config_find_fs_id(server_config, ref.fs_id);
    PINT_put_server_config_struct(server_config);

    if (!cur_fs)
    {
        gossip_lerr("Error: invalid fs_id.\n");
        return ret;
    }

    /* look for zero byte operations */
    if ((PINT_REQUEST_TOTAL_BYTES(mem_req) == 0) ||
        (PINT_REQUEST_TOTAL_BYTES(file_req) == 0))
    {
        gossip_ldebug(GOSSIP_IO_DEBUG, "Warning: 0 byte I/O operation "
                      "attempted.\n");
        resp_p->total_completed = 0;
        return 0;
    }

    sm_p = (PINT_client_sm *)malloc(sizeof(*sm_p));
    if (sm_p == NULL)
    {
        return -PVFS_ENOMEM;
    }
    memset(sm_p, 0, sizeof(*sm_p));

    PINT_init_sysint_credentials(sm_p->cred_p, credentials);
    sm_p->object_ref = ref;
    sm_p->u.io.io_type = io_type;
    sm_p->u.io.file_req = file_req;
    sm_p->u.io.file_req_offset = file_req_offset;
    sm_p->u.io.io_resp_p = resp_p;
    sm_p->u.io.mem_req = mem_req;
    sm_p->u.io.buffer = buffer; 
    sm_p->u.io.flowproto_type = cur_fs->flowproto;
    sm_p->u.io.encoding = cur_fs->encoding;
    sm_p->u.io.stored_error_code = 0;
    sm_p->u.io.retry_count = 0;
    sm_p->u.io.datafile_handles = NULL;
    sm_p->u.io.datafile_index_array = NULL;
    sm_p->msgarray = NULL;
    sm_p->u.io.dist_p = NULL;
    sm_p->u.io.dist_size = 0;
    sm_p->u.io.datafile_handles = NULL;
    sm_p->u.io.datafile_count = 0;
    sm_p->u.io.flow_array = NULL;
    sm_p->u.io.flow_status_array = NULL;
    sm_p->u.io.session_tag_array = NULL;
    sm_p->u.io.ackarray = NULL;

    return PINT_client_state_machine_post(
        sm_p, PVFS_SYS_IO, op_id, user_ptr);
}

int PVFS_sys_io(
    PVFS_object_ref ref,
    PVFS_Request file_req,
    PVFS_offset file_req_offset,
    void *buffer,
    PVFS_Request mem_req,
    PVFS_credentials *credentials,
    PVFS_sysresp_io *resp_p,
    enum PVFS_io_type io_type)
{
    int ret = -PVFS_EINVAL;
    PVFS_error error;
    PVFS_sys_op_id op_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "PVFS_sys_io entered\n");

    ret = PVFS_isys_io(ref, file_req, file_req_offset, buffer, mem_req,
                       credentials, resp_p, io_type, &op_id, NULL);
    if (ret)
    {
        PVFS_perror_gossip("PVFS_isys_io call", ret);
        error = ret;
    }
    else
    {
        ret = PINT_sys_wait(op_id, "io", &error);
        if (ret)
        {
            PVFS_perror_gossip("PVFS_sys_wait call", ret);
            error = ret;
        }
    }

    PINT_sys_release(op_id);
    return error;
}

/*******************************************************************/

static int io_init(PINT_client_sm *sm_p,
                   job_status_s *js_p)
{
    job_id_t tmp_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "io state: init\n");

    assert((js_p->error_code == 0) ||
           (js_p->error_code == IO_RETRY));

    if (js_p->error_code == IO_RETRY)
    {
        js_p->error_code = 0;

        return job_req_sched_post_timer(
            PVFS2_CLIENT_RETRY_DELAY, sm_p, 0, js_p, &tmp_id,
            pint_client_sm_context);
    }
    return 1;
}


/* io_datafile_setup_msgpairs()
 *
 * Sets up msgpairs to send I/O requests to servers holding datafiles
 * that (might) have data for us (unless we hit EOF).
 *
 * This function swaps the original datafile_handles array for a new
 * array that just has datafiles that we think will have our data.  It
 * updates datafile_count appropriately as well.
 *
 * We use sm_p->msgarray for this purpose.
 *
 * NOTE: we could combine this with the post_msgpairs state, but this one
 *       has gotten pretty big already, so let's not.
 *
 */
static int io_datafile_setup_msgpairs(PINT_client_sm *sm_p,
                                      job_status_s *js_p)
{
    int ret = -PVFS_EINVAL, i = 0;
    int target_datafile_count = 0;
    PVFS_object_attr *attr = NULL;
    PVFS_handle *target_datafile_array = NULL;
    struct PINT_client_io_sm *iosm_p = &sm_p->u.io;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "(%p) io state: "
                 "io_datafile_setup_msgpairs\n", sm_p);

    js_p->error_code = 0;

    attr = (sm_p->acache_hit ?
            &sm_p->pinode->attr :
            &sm_p->acache_attr);
    assert(attr);

    switch(attr->objtype)
    {
        case PVFS_TYPE_METAFILE:
            assert(attr->objtype == PVFS_TYPE_METAFILE);
            assert(attr->mask & PVFS_ATTR_META_DFILES);
            assert(attr->mask & PVFS_ATTR_META_DIST);
            assert(attr->u.meta.dist_size > 0);
            assert(attr->u.meta.dfile_array);
            assert(attr->u.meta.dfile_count > 0);
            break;
        case PVFS_TYPE_DIRECTORY:
            js_p->error_code = -PVFS_EISDIR;
            return 1;
        default:
            js_p->error_code = -PVFS_EIO;
            return 1;
    }

    /*
      assign internal io ptrs for convenience here (without copying)
      if unassigned
    */
    if (!sm_p->u.io.dist_p)
    {
        sm_p->u.io.dist_p = attr->u.meta.dist;
    }
    if (!sm_p->u.io.dist_size)
    {
        sm_p->u.io.dist_size = attr->u.meta.dist_size;
    }
    if (!sm_p->u.io.datafile_handles)
    {
        sm_p->u.io.datafile_handles = attr->u.meta.dfile_array;
    }
    if (!sm_p->u.io.datafile_count)
    {
        sm_p->u.io.datafile_count = attr->u.meta.dfile_count;
    }

    ret = PINT_dist_lookup(iosm_p->dist_p);
    assert(ret == 0);

    if (!target_datafile_array)
    {
        target_datafile_array = (PVFS_handle *)malloc(
            (iosm_p->datafile_count * sizeof(PVFS_handle)));
    }
    if (!target_datafile_array)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return 1;
    }

    if (!iosm_p->datafile_index_array)
    {
        iosm_p->datafile_index_array = (int *)malloc(
            (iosm_p->datafile_count * sizeof(int)));
    }
    if (!iosm_p->datafile_index_array)
    {
        goto malloc_error_exit;
    }

    ret = io_find_target_datafiles(
        iosm_p->mem_req,
        iosm_p->file_req,
        iosm_p->file_req_offset,
        iosm_p->dist_p,
        iosm_p->datafile_handles,
        iosm_p->datafile_count,
        target_datafile_array,
        iosm_p->datafile_index_array,
        &target_datafile_count);
    assert(ret == 0);

    if (target_datafile_count == 0)
    {
        if (target_datafile_array)
        {
            free(target_datafile_array);
            target_datafile_array = NULL;
        }

        if (iosm_p->datafile_index_array)
        {
            free(iosm_p->datafile_index_array);
            iosm_p->datafile_index_array = NULL;
        }

        /* the no data case should be caught earlier than this */
        js_p->error_code = IO_NO_DATA;
        return 1;
    }

    gossip_debug(GOSSIP_IO_DEBUG,
                 "  datafile_setup_msgpairs: %d datafiles "
                 "might have data\n", target_datafile_count);

    /* setup msgpair array */
    if (!sm_p->msgarray)
    {
        sm_p->msgarray = (PINT_client_sm_msgpair_state *)malloc(
            (target_datafile_count *
             sizeof(PINT_client_sm_msgpair_state)));
    }
    if (!sm_p->msgarray)
    {
        goto malloc_error_exit;
    }
    sm_p->msgarray_count = target_datafile_count;

    /* setup flow descriptor array */
    if (!iosm_p->flow_array)
    {
        iosm_p->flow_array = (flow_descriptor *)malloc(
            (target_datafile_count * sizeof(flow_descriptor)));
    }
    if (!iosm_p->flow_array)
    {
        goto malloc_error_exit;
    }
    iosm_p->flow_comp_ct = 0;

    /* set each flow descriptor to initial values */
    for(i = 0; i < target_datafile_count; i++)
    {
        PINT_flow_reset(&iosm_p->flow_array[i]);
    }

    /* setup flow status array */
    if (!iosm_p->flow_status_array)
    {
        iosm_p->flow_status_array = (job_status_s *)malloc(
            (target_datafile_count * sizeof(job_status_s)));
    }
    if (!iosm_p->flow_status_array)
    {
        goto malloc_error_exit;
    }

    /* setup session tag array */
    if (!iosm_p->session_tag_array)
    {
        iosm_p->session_tag_array = (PVFS_msg_tag_t *)malloc(
            (target_datafile_count * sizeof(PVFS_msg_tag_t)));
    }
    if (!iosm_p->session_tag_array)
    {
        goto malloc_error_exit;
    }

    /* setup space for final ack if we're doing a write */
    if (iosm_p->io_type == PVFS_IO_WRITE)
    {
        /* setup the write acknowledgement array */
        if (!iosm_p->ackarray)
        {
            iosm_p->ackarray = (PINT_client_sm_recv_state *)malloc(
                (target_datafile_count *
                 sizeof(PINT_client_sm_recv_state)));
        }
        if (!iosm_p->ackarray)
        {
            goto malloc_error_exit;
        }
        memset(iosm_p->ackarray, 0,
            target_datafile_count*sizeof(PINT_client_sm_recv_state));
        iosm_p->ack_comp_ct = 0;
    }

    /* fill in all the I/O requests */
    for (i = 0; i < target_datafile_count; i++)
    {
        int orig_index = 0;
        PINT_client_sm_msgpair_state *msg_p = &sm_p->msgarray[i];
        assert(msg_p);

        gossip_debug(GOSSIP_IO_DEBUG, "  sending I/O request "
                     "for %Lu\n", Lu(target_datafile_array[i]));

        /* find the original index for the handle */
        for (orig_index = 0; orig_index < iosm_p->datafile_count;
             orig_index++)
        {
            if (target_datafile_array[i] ==
                iosm_p->datafile_handles[orig_index])
            {
                break;
            }
        }
        assert(orig_index < iosm_p->datafile_count);

        PINT_SERVREQ_IO_FILL(
            msg_p->req,
            *sm_p->cred_p,
            sm_p->object_ref.fs_id,
            target_datafile_array[i],
            iosm_p->io_type,
            iosm_p->flowproto_type,
            orig_index,
            iosm_p->datafile_count,
            iosm_p->dist_p,
            iosm_p->file_req,
            iosm_p->file_req_offset,
            PINT_REQUEST_TOTAL_BYTES(iosm_p->mem_req));

        /* fill in msgpair structure components */
        msg_p->fs_id = sm_p->object_ref.fs_id;
        msg_p->handle = target_datafile_array[i];
        msg_p->retry_flag = PVFS_MSGPAIR_NO_RETRY;
        msg_p->comp_fn = NULL;

        ret = PINT_bucket_map_to_server(&msg_p->svr_addr,
                                        msg_p->handle,
                                        msg_p->fs_id);
        if (ret)
        {
            gossip_err("Failed to map meta server address\n");
            js_p->error_code = ret;
            return 1;
        }
    }

    /* swap the new list in for the old one, freeing the old list */
    if (!sm_p->acache_hit && iosm_p->datafile_handles)
    {
        free(iosm_p->datafile_handles);
    }

    if (target_datafile_array)
    {
        iosm_p->datafile_handles = target_datafile_array;
    }

    /*
      store the original datafile_count before it's modified,
      as we'll need it later in io_datafile_complete_msgpairs
    */
    iosm_p->orig_datafile_count = iosm_p->datafile_count;
    iosm_p->datafile_count = target_datafile_count;

    return 1;

  malloc_error_exit:
    CLEAN_PRIVATE_MEMBERS(iosm_p);

    js_p->error_code = -PVFS_ENOMEM;
    return 1;
}

/* io_datafile_post_msgpairs()
 *
 * This is basically a copy of msgpairarray.c:msgpairarray_post().
 * We need to handle the rest of the process somewhat differently though,
 * so we're going to have our own versions here.
 *
 * We use the msgarray to keep up with the initial send/recv pairs.
 *
 */
static int io_datafile_post_msgpairs(PINT_client_sm *sm_p,
                                     job_status_s *js_p)
{
    int ret = -PVFS_EINVAL, i = 0;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "io_datafile_post_msgpairs "
                 "state: post (%d message(s))\n", sm_p->msgarray_count);

    js_p->error_code = 0;

    /* set number of operations that must complete.
     *
     * NOTE: we're using the comp_ct in the first msgpair
     * entry to keep up with the count for the entire array.
     */
    assert(sm_p->msgarray);
    assert(sm_p->msgarray_count > 0);

    sm_p->msgarray[0].comp_ct = (2 * sm_p->msgarray_count);

    for (i = 0; i < sm_p->msgarray_count; i++)
    {
        PVFS_msg_tag_t session_tag;
        PINT_client_sm_msgpair_state *msg_p = &sm_p->msgarray[i];
        assert(msg_p);

        ret = PINT_encode(&msg_p->req,
                          PINT_ENCODE_REQ,
                          &msg_p->encoded_req,
                          msg_p->svr_addr,
                          sm_p->u.io.encoding);
        if (ret != 0)
        {
            gossip_lerr("pint_encode failed\n");
            js_p->error_code = -PVFS_EIO;
            return 1;
        }

        /* calculate maximum response message size and allocate space.
         * fills in max_resp_sz, encoded_resp_p
         */
        msg_p->max_resp_sz = PINT_encode_calc_max_size(
            PINT_ENCODE_RESP, msg_p->req.op, sm_p->u.io.encoding);
        msg_p->encoded_resp_p = BMI_memalloc(
            msg_p->svr_addr, msg_p->max_resp_sz, BMI_RECV);
        if (!msg_p->encoded_resp_p)
        {
            js_p->error_code = -PVFS_ENOMEM;
            return 1;
        }

        /* get session tag to associate with send and receive.
         * session tag is kept in io part of client state machine
         * structure for use in the flow and option final ack.
         */
        session_tag = get_next_session_tag();
        sm_p->u.io.session_tag_array[i] = session_tag;

        /* post receive of response; job_id stored in recv_id */
        ret = job_bmi_recv(
            msg_p->svr_addr,
            msg_p->encoded_resp_p,
            msg_p->max_resp_sz,
            session_tag,
            BMI_PRE_ALLOC,
            sm_p,
            i,
            &msg_p->recv_status,
            &msg_p->recv_id,
            pint_client_sm_context,
	    PVFS2_CLIENT_JOB_TIMEOUT);

        if (ret != 0)
        {
            /* it shouldn't be possible for the receive to complete
             * before we send the request.
             */
            assert(ret != 1);

            gossip_lerr("post of receive failed (ret = %d)\n", ret);
            js_p->error_code = -PVFS_EIO;
            return 1;
        }

        /* post send of request; job_id stored in send_id */
        ret = job_bmi_send_list(
            msg_p->encoded_req.dest,
            msg_p->encoded_req.buffer_list,
            msg_p->encoded_req.size_list,
            msg_p->encoded_req.list_count,
            msg_p->encoded_req.total_size,
            session_tag,
            msg_p->encoded_req.buffer_type,
            1,
            sm_p,
            (sm_p->msgarray_count + i),
            &msg_p->send_status,
            &msg_p->send_id,
            pint_client_sm_context,
	    PVFS2_CLIENT_JOB_TIMEOUT);

        if (ret < 0)
        {
            gossip_lerr("post of send failed\n");
            js_p->error_code = -PVFS_EIO;
            return 1;
        }
        else if (ret == 1)
        {
            /*
              send completed immediately; decrement the completion
              counter
            */
            gossip_debug(
                GOSSIP_IO_DEBUG, "  io_datafile_post_msgpairs: "
                "send completed immediately.\n");

            /* 0 is the valid "completed job id" value */
            msg_p->send_id = 0;

            if (msg_p->send_status.error_code != 0)
            {
                PVFS_perror_gossip(
                    "sys-io.sm: msg_p->send_status.error_code",
                    msg_p->send_status.error_code);
                js_p->error_code = msg_p->send_status.error_code;
                return 1;
            }

            /* decrement our count, since send is already done.
             *
             * recall we're using the comp_ct in the first array
             * element to keep up with our count for the entire
             * array.
             */
            sm_p->msgarray[0].comp_ct--;
        }
    }
    return 0;
}

/* io_datafile_complete_msgpairs()
 *
 * This started off as a copy of msgpairarray.c:msgpairarray_complete(),
 * but we need to post flow operations as the bmi operations complete,
 * so we have some additional work to do.
 */
static int io_datafile_complete_msgpairs(PINT_client_sm *sm_p,
                                         job_status_s *js_p)
{
    int i = 0, ret = -1;
    int matched_msgpair = 0, matched_flow = 0;
    int matched_ack = 0, recv_match = -1;
    job_id_t tmp_id;
    PINT_client_sm_msgpair_state *msg_p = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "io state: "
                 "datafile_complete_msgpairs\n");

    assert(sm_p->msgarray_count == sm_p->u.io.datafile_count);
    assert(sm_p->msgarray[0].comp_ct >= 0);
    assert(sm_p->u.io.flow_comp_ct >= 0);
    assert(sm_p->u.io.ack_comp_ct >= 0);
    assert(js_p->status_user_tag < (sm_p->msgarray_count*4));

    /* if there are outstanding msgpairs to complete, try to match
     * whatever completed with something in the msgpair array
     */
    if (sm_p->msgarray[0].comp_ct > 0)
    {
        if (js_p->status_user_tag < sm_p->msgarray_count)
        {
            /* first N user tags are for receives */
            i = js_p->status_user_tag;
            msg_p = &sm_p->msgarray[i];
            matched_msgpair = 1;
            recv_match = js_p->status_user_tag;
            msg_p->recv_id     = 0;
            msg_p->recv_status = *js_p;
            assert(msg_p->recv_status.actual_size <= msg_p->max_resp_sz);
            assert(msg_p->recv_status.error_code <= 0);
        }
        else if (js_p->status_user_tag < (sm_p->msgarray_count*2))
        {
            /* second N user tags are for sends */
            i = js_p->status_user_tag - sm_p->msgarray_count;
            msg_p = &sm_p->msgarray[i];
            matched_msgpair = 1;
            msg_p->send_id     = 0;
            msg_p->send_status = *js_p;
            assert(msg_p->send_status.error_code <= 0);
        }

        if (matched_msgpair)
        {
            /* decrement comp_ct until all operations have completed */
            sm_p->msgarray[0].comp_ct--;

            if (sm_p->msgarray[0].comp_ct == 0)
            {
                gossip_debug(GOSSIP_IO_DEBUG, "all msgpairs complete.\n");
            }
        }
    }

    if (matched_msgpair && (recv_match == -1))
    {
        gossip_debug(GOSSIP_IO_DEBUG,
                     "  matched send to %d; continuing.\n", i);
        return 0;
    }

    /* if we matched a receive, then we need to decode the receive,
     * post the appropriate flow, and possibly post the receive of an ack
     * BMI message (if a write operation).
     *
     * we use the same index into the various arrays in the io part of the
     * state machine state that we used for this receive job (recv_match).
     */
    if (recv_match != -1)
    {
        struct PINT_decoded_msg decoded_resp;
        struct PVFS_server_resp *resp_p = NULL;

        gossip_debug(GOSSIP_IO_DEBUG, "  matched response from %d.\n", i);

        ret = PINT_serv_decode_resp(
	    msg_p->fs_id,
            msg_p->encoded_resp_p, &decoded_resp, &msg_p->svr_addr,
            msg_p->recv_status.actual_size, &resp_p);
        if (ret != 0)
        {
            gossip_lerr("io_datafile_complete_msgpairs: decode error\n");
            assert(0);
        }

        assert(resp_p->status <= 0);
        msg_p->op_status = resp_p->status;

        /* note: we saved the recv_status up above (before decoding) */
        if ((msg_p->recv_status.error_code != 0) ||
            (msg_p->op_status != 0))
        {
            if (msg_p->recv_status.error_code)
            {
                PVFS_perror_gossip("io_datafile_complete_msgpairs",
                                   msg_p->recv_status.error_code);
            }
            gossip_debug(GOSSIP_IO_DEBUG, "  error %d with status %d "
                         "related to response from %d; not submitting "
                         "flow.\n", msg_p->recv_status.error_code,
                         msg_p->op_status, recv_match);

            if (msg_p->op_status)
            {
                js_p->error_code = -PVFS_EIO;
                return 1;
            }

            ret = PINT_serv_free_msgpair_resources(
                &msg_p->encoded_req, msg_p->encoded_resp_p,
                &decoded_resp, &msg_p->svr_addr, msg_p->max_resp_sz);
            assert(ret == 0);

            return 0;
        }
        else
        {
            flow_descriptor *fl_p = NULL;
            struct PINT_client_io_sm *iosm_p = &sm_p->u.io;

            gossip_debug(GOSSIP_IO_DEBUG, "  building flow for %d.\n",
                         recv_match);

            /* find matching flow descriptor */
            fl_p = &sm_p->u.io.flow_array[recv_match];

            /* fill in file_data structure */
            fl_p->file_data.fsize = resp_p->u.io.bstream_size;
            fl_p->file_data.dist = iosm_p->dist_p;
            fl_p->file_data.server_nr =
                iosm_p->datafile_index_array[recv_match];
            fl_p->file_data.server_ct = iosm_p->orig_datafile_count;

            /* this is the file datatype */
            fl_p->file_req = iosm_p->file_req;
            fl_p->file_req_offset = iosm_p->file_req_offset;

            /* this is the memory datatype */
            fl_p->mem_req = iosm_p->mem_req;

            gossip_debug(
                GOSSIP_IO_DEBUG, "    bstream_size = %Ld, datafile_nr = "
                "%d, datafile_ct = %d, file_req_off = %Ld\n",
                Ld(fl_p->file_data.fsize), fl_p->file_data.server_nr,
                fl_p->file_data.server_ct, Ld(fl_p->file_req_offset));

            /* session tag, same as the one used in the send/recv */
            fl_p->tag = iosm_p->session_tag_array[recv_match];

            /* this user_ptr should be left alone */
            fl_p->user_ptr = NULL;

            fl_p->type = iosm_p->flowproto_type;

            /* done with msgpair resources; free them now */
            ret = PINT_serv_free_msgpair_resources(
                &msg_p->encoded_req, msg_p->encoded_resp_p,
                &decoded_resp, &msg_p->svr_addr, msg_p->max_resp_sz);
            assert(ret == 0);
            
            resp_p = NULL;

            if (iosm_p->io_type == PVFS_IO_READ)
            {
                /* Set up read-specific values
                 * - don't keep going past EOF
                 * - data is coming from BMI and going into memory
                 * - data is coming from the same server we got the recv from
                 */
                fl_p->file_data.extend_flag = 0;
                fl_p->src.endpoint_id = BMI_ENDPOINT;
                fl_p->src.u.bmi.address = msg_p->svr_addr;
                fl_p->dest.endpoint_id = MEM_ENDPOINT;
                fl_p->dest.u.mem.buffer = iosm_p->buffer;
            }
            else
            {
                assert (iosm_p->io_type == PVFS_IO_WRITE);

                /* do allow writes to extend the file */
                fl_p->file_data.extend_flag = 1;
                fl_p->src.endpoint_id = MEM_ENDPOINT;
                fl_p->src.u.mem.buffer = iosm_p->buffer;
                fl_p->dest.endpoint_id = BMI_ENDPOINT;
                fl_p->dest.u.bmi.address = msg_p->svr_addr;

                gossip_debug(GOSSIP_IO_DEBUG, "  preposting write "
                             "ack for %d.\n", recv_match);

                /* prepost the ack receive now */
                iosm_p->ackarray[recv_match].max_resp_sz =
                    PINT_encode_calc_max_size(
                        PINT_ENCODE_RESP, PVFS_SERV_WRITE_COMPLETION,
                        iosm_p->encoding);
                iosm_p->ackarray[recv_match].encoded_resp_p =
                    BMI_memalloc(
                        msg_p->svr_addr,
                        iosm_p->ackarray[recv_match].max_resp_sz,
                        BMI_RECV);
                assert(iosm_p->ackarray[recv_match].encoded_resp_p);

                ret = job_bmi_recv(
                    msg_p->svr_addr,
                    iosm_p->ackarray[recv_match].encoded_resp_p,
                    iosm_p->ackarray[recv_match].max_resp_sz,
                    iosm_p->session_tag_array[recv_match],
                    BMI_PRE_ALLOC,
                    sm_p,
                    (sm_p->msgarray_count*3 + recv_match),
                    &iosm_p->ackarray[recv_match].recv_status,
                    &iosm_p->ackarray[recv_match].recv_id,
                    pint_client_sm_context,
		    PVFS2_CLIENT_JOB_TIMEOUT);

                if (ret < 0)
                {
                    gossip_lerr("post of write ack failed\n");
                    assert(0);
                }
                assert(ret == 0);
                
                iosm_p->ack_comp_ct++;
            }

            /* post the flow:
             * - pass sm_p in as user pointer, so we get called again
             * - have status stored in flow status array, if we complete
             *   immed.
             * - save id in flow id array
             * - use recv_match as index for all this
             */
            ret = job_flow(
                fl_p, sm_p, (sm_p->msgarray_count*2 + recv_match),
                &iosm_p->flow_status_array[recv_match], &tmp_id,
                pint_client_sm_context, PVFS2_CLIENT_JOB_TIMEOUT);

            if (ret < 0)
            {
                gossip_lerr("post of flow failed.\n");
                assert(0);
            }
            else if (ret == 1)
            {
                /* flow completed immediately */
                gossip_debug(GOSSIP_IO_DEBUG, "  flow for %d completed "
                             "immediately!\n", recv_match);
                assert(!iosm_p->flow_status_array[recv_match].error_code);
            }
            else
            {
                assert(ret == 0);

                gossip_debug(GOSSIP_IO_DEBUG, "  posted flow for %d.\n",
                             recv_match);

                /* record that we have a flow that still needs to complete */
                iosm_p->flow_comp_ct++;
            }
        }
        return 0;
    }

    /* check to ensure we caught all exits above */
    assert(matched_msgpair == 0);

    /* if we didn't match to a message pair, then we completed either
     * a flow or a write ack
     */
    gossip_debug(GOSSIP_IO_DEBUG, "  trying to match to a flow or ack.\n");

    if ((js_p->status_user_tag >= (sm_p->msgarray_count*2)) &&
        (js_p->status_user_tag < (sm_p->msgarray_count*3)))
    {
        /* the third set of N user tags correspond to flows */
        matched_flow = 1;
        i = js_p->status_user_tag - (sm_p->msgarray_count*2);
        sm_p->u.io.flow_status_array[js_p->status_user_tag -
                                     (sm_p->msgarray_count*2)] = *js_p;
        sm_p->u.io.flow_comp_ct--;
        gossip_debug(GOSSIP_IO_DEBUG,
                     "  matched completed flow for %d\n", i);

        assert(sm_p->u.io.flow_comp_ct >= 0);
    }
    else if (js_p->status_user_tag >= (sm_p->msgarray_count*3))
    {
        /* the fourth set of N user tags correspond to final acks */
        matched_ack = 1;
        i = js_p->status_user_tag - (sm_p->msgarray_count*3);
        sm_p->u.io.ackarray[i].recv_id      = 0;
        sm_p->u.io.ackarray[i].recv_status = *js_p;
        assert(sm_p->u.io.ackarray[i].recv_status.actual_size <=
               sm_p->u.io.ackarray[i].max_resp_sz);
        sm_p->u.io.ack_comp_ct--;
        gossip_debug(GOSSIP_IO_DEBUG,
                     "  matched completed ack for %d\n", i);

        assert(sm_p->u.io.ack_comp_ct >= 0);
    }
    
    if ((sm_p->u.io.flow_comp_ct == 0) &&
        (sm_p->u.io.ack_comp_ct == 0) &&
        (sm_p->msgarray[0].comp_ct == 0))
    {
        gossip_debug(GOSSIP_IO_DEBUG,
                     "  all msgpairs, flows, ack completed.\n");

        js_p->error_code = IO_DATAFILE_TRANSFERS_COMPLETE;
        return 1;
    }

    /* there's still something left to transfer */
    return 0;
}

static int io_object_getattr_failure(PINT_client_sm *sm_p,
                                     job_status_s *js_p)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG, "(%p) io state: "
                 "io_object_getattr_failure\n", sm_p);

    /*
      NOTE: this can easily happen if we're doing I/O on a file that
      was removed by another process
    */
    if (js_p->error_code == 0)
    {
        js_p->error_code = -PVFS_ENOENT;
    }

    sm_p->u.io.stored_error_code = js_p->error_code;
    return 1;
}

static int io_analyze_results(PINT_client_sm *sm_p,
                              job_status_s *js_p)
{
    int i = 0, ret = -PVFS_EINVAL, error = 0, error_count = 0;
    PVFS_size total_size = 0;
    struct PINT_client_io_sm *iosm_p = &sm_p->u.io;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "(%p) io state: "
                 "analyze_results\n", sm_p);

    if (js_p->error_code != IO_DATAFILE_TRANSFERS_COMPLETE)
    {
        /* some sort of error occurred early on */
        js_p->error_code = (sm_p->u.io.stored_error_code ?
                            sm_p->u.io.stored_error_code :
                            js_p->error_code);
        if (js_p->error_code == 0)
        {
            js_p->error_code = -PVFS_EIO;
        }
        error = js_p->error_code;
    }
    else
    {
        /* it's possible that some error occurred still.  look through
         * all the messages, reporting errors, saving the first one to
         * return, and adding up the size of the transfer (just in
         * case things actually completed).
         */
        for(i = 0; i < sm_p->msgarray_count; i++)
        {
            PINT_client_sm_msgpair_state *msg_p = &sm_p->msgarray[i];

            if (msg_p->send_status.error_code != 0)
            {
                gossip_debug(GOSSIP_IO_DEBUG,
                             "  error (%d) in msgpair send for %d.\n",
                             msg_p->send_status.error_code, i);
                error_count++;
                if (error == 0)
                {
                    error = msg_p->send_status.error_code;
                }
            }
            else if (msg_p->recv_status.error_code != 0)
            {
                gossip_debug(GOSSIP_IO_DEBUG,
                             "  error (%d) in msgpair recv for %d.\n",
                             msg_p->recv_status.error_code, i);
                error_count++;
                if (error == 0)
                {
                    error = msg_p->recv_status.error_code;
                }
            }
            else if (iosm_p->flow_array[i].file_req != NULL)
            {
                /* NOTE: this is a little bit of a hack to determine if we
                 * have actually used this flow descriptor; we don't
                 * really care what the file_req is
                 */
                if (iosm_p->flow_status_array[i].error_code != 0)
                {
                    gossip_debug(
                        GOSSIP_IO_DEBUG, "  error (%d) in flow for %d.\n",
                        iosm_p->flow_status_array[i].error_code, i);
                    error_count++;
                    if (error == 0)
                    {
                        error = iosm_p->flow_status_array[i].error_code;
                    }
                }
                else if (iosm_p->io_type == PVFS_IO_READ)
                {
                    /* size for reads is reported in the flow;
                     * size for writes is reported in the final ack.
                     */
                    gossip_debug(
                        GOSSIP_IO_DEBUG, "  %Ld bytes read from %d.\n",
                        Ld(iosm_p->flow_array[i].total_transfered), i);
                    total_size += iosm_p->flow_array[i].total_transfered;
                }
                else if (iosm_p->io_type == PVFS_IO_WRITE)
                {
                    if (iosm_p->ackarray[i].recv_status.error_code != 0)
                    {
                        gossip_debug(
                            GOSSIP_IO_DEBUG,
                            "  error (%d) in write ack for %d.\n",
                            iosm_p->ackarray[i].recv_status.error_code,
                            i);
                        error_count++;
                        if (error == 0)
                        {
                            error = iosm_p->ackarray[i].recv_status.error_code;
                        }
                    }
                    else
                    {
                        struct PINT_decoded_msg decoded_resp;
                        struct PVFS_server_resp *resp_p = NULL;

                        /* we need to decode the write ack so we can
                         * see how much data we were actually able to
                         * write.
                         *
                         * note: we just use the svr_addr from the
                         * msgpair; it's the same address.
                         */
                        ret = PINT_serv_decode_resp(
			    msg_p->fs_id,
                            iosm_p->ackarray[i].encoded_resp_p,
                            &decoded_resp,
                            &msg_p->svr_addr,
                            iosm_p->ackarray[i].recv_status.actual_size,
                            &resp_p);
                        assert(ret == 0);

                        gossip_debug(
                            GOSSIP_IO_DEBUG, "%Ld bytes written to %d.\n",
                            Ld(resp_p->u.write_completion.total_completed),
                            i);
                        total_size +=
                            resp_p->u.write_completion.total_completed;

                        PINT_decode_release(&decoded_resp, PINT_DECODE_RESP);
                    }
                }

                /* free resources associated with this flow array
                 * element: - write ack, if it was a write (we decoded
                 * it if we needed to above, and got rid of that
                 * already)
                 */
                PINT_flow_reset(&sm_p->u.io.flow_array[i]);
                if (iosm_p->io_type == PVFS_IO_WRITE)
                {
                    BMI_memfree(msg_p->svr_addr,
                                iosm_p->ackarray[i].encoded_resp_p,
                                iosm_p->ackarray[i].max_resp_sz,
                                BMI_RECV);
                }
            }
        }
    }

    if (!sm_p->acache_hit)
    {
        free(sm_p->u.io.datafile_handles);
        sm_p->u.io.datafile_handles = NULL;
    }

    /*
      FIXME: non bmi errors pop out in flow failures above -- they are
      not properly marked as flow errors either, so we check for them
      explicitly here (but not all -- fix it for real).
    */
    if (((PVFS_ERROR_CLASS(-error) == PVFS_ERROR_BMI) ||
         (PVFS_ERROR_CLASS(-error) == PVFS_ERROR_FLOW) ||
         (error == -ECONNRESET)) &&
        (sm_p->u.io.retry_count < PVFS2_CLIENT_RETRY_LIMIT))
    {
        if (sm_p->acache_hit || sm_p->pinode)
        {
            sm_p->acache_hit = 0;
            PINT_acache_release(sm_p->pinode);
            sm_p->pinode = NULL;
        }

        sm_p->u.io.stored_error_code = 0;
        sm_p->u.io.retry_count++;

        gossip_debug(GOSSIP_IO_DEBUG, "Retrying I/O operation "
                     "(attempt number %d)\n", sm_p->u.io.retry_count);

        js_p->error_code = IO_RETRY;
        return 1;
    }

    CLEAN_PRIVATE_MEMBERS(iosm_p);

    /* return size, error, and set operation as complete */
    sm_p->u.io.io_resp_p->total_completed = total_size;
    sm_p->error_code = (sm_p->u.io.stored_error_code ?
                        sm_p->u.io.stored_error_code : error);
    sm_p->op_complete = 1;

    return 0;
}

/********************************************************************/

/* io_find_target_datafiles()
 *
 * determines what subset of the datafiles actually contain data that
 * we are interested in for this request
 *
 * returns 0 on success, -pvfs_error on failure
 *
 */
static int io_find_target_datafiles(PVFS_Request mem_req,
                                    PVFS_Request file_req,
                                    PVFS_offset file_req_offset,
                                    PINT_dist *dist_p,
                                    PVFS_handle *input_handle_array,
                                    int input_handle_count,
                                    PVFS_handle *output_handle_array,
                                    int* handle_index_array,
                                    int *handle_count_out_p)
{
    int i, ret;
    struct PINT_Request_state *req_state = NULL;
    struct PINT_Request_state *mem_req_state = NULL;
    PINT_Request_file_data tmp_file_data;
    PINT_Request_result tmp_result;

    *handle_count_out_p = 0;

    req_state = PINT_New_request_state(file_req);
    if (!req_state)
    {
        return -PVFS_ENOMEM;
    }
    mem_req_state = PINT_New_request_state(mem_req);
    if (!mem_req_state)
    {
        PINT_Free_request_state(req_state);
        return -PVFS_ENOMEM;
    }

    tmp_file_data.dist = dist_p;
    tmp_file_data.server_ct = input_handle_count;
    tmp_file_data.extend_flag = 1;

    for(i = 0; i < input_handle_count; i++)
    {
        /* NOTE: we don't have to give an accurate file size here, as
         * long as we set the extend flag to tell the I/O req
         * processor to continue past eof if needed
         */
        tmp_file_data.fsize = 0;  
        tmp_file_data.server_nr = i;

        PINT_REQUEST_STATE_RESET(req_state);
        PINT_REQUEST_STATE_RESET(mem_req_state);

        /* if a file datatype offset was specified, go ahead and skip
         * ahead before calculating
         */
        if (file_req_offset)
        {
            PINT_REQUEST_STATE_SET_TARGET(req_state, file_req_offset);
        }

        PINT_REQUEST_STATE_SET_FINAL(req_state,
            file_req_offset+PINT_REQUEST_TOTAL_BYTES(mem_req));

        memset(&tmp_result, 0, sizeof(PINT_Request_result));
        tmp_result.bytemax = 1;
        tmp_result.segmax = 1;

        /* PINT_Process_request() returns number of bytes processed */
        ret = PINT_Process_request(
            req_state, mem_req_state, &tmp_file_data,
            &tmp_result, PINT_CKSIZE);
        if (ret < 0)
        {
            PINT_Free_request_state(mem_req_state);
            PINT_Free_request_state(req_state);
            return ret;
        }

        /* did we find that any data belongs to this handle? */
        if (tmp_result.bytes != 0)
        {
            assert(tmp_result.bytes > 0);

            gossip_debug(GOSSIP_IO_DEBUG, "io_find_target_dfiles: "
                         "datafile %d might have some data.\n", i);

            output_handle_array[*handle_count_out_p] =
                input_handle_array[i]; 
            handle_index_array[*handle_count_out_p] = i;
            (*handle_count_out_p)++;
        }
    }
    PINT_Free_request_state(req_state);
    PINT_Free_request_state(mem_req_state);

    return 0;
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 noexpandtab
 */
